<?php
/****************************************************************************************************************/
/* (c) 17.03.2007 by Tobias Sorn                                                                                */
/* Version: 0.03c                                                                                               */
/* Voraussetzung: Logfile des page-restrictor ab Version 0.08j                                                  */
/* Infos: Log-Eintrge aus vorherigen Versionen werden nicht ausgewertet, knnen aber im Logfile stehen bleiben */
/****************************************************************************************************************/
/* fuer pragmaMx Vers.0.1.10 angepasst:                                                                         */
/* Vers. 1.2 Copyright (c) 01.03.2008 by Gerd Warblow (607), http//www.warblow.de                               */
/****************************************************************************************************************/
if (!defined("mxAdminFileLoaded")) die("Access Denied");
if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
} 
	$module_name = RESTRICTOR_LOG_MODULE_NAME;
	$logfile = './restrictor/log/'.date("Ymd").'.log';//Beispiel fuer ein taegl. neues LogFile
	$logfile_name = date("Ymd").'.log';

//Sind die Logs in einem Verzeichnis, kann man auch einfach nur dieses angeben.
//Beispiel: $logfile = './verzeichnis/';
//Wichtig ist, dass der Pfad mit / endet
//Ihr hab dann im Script eine Auswahlmglichkeit des Logfiles aus dem Verzeichnis
	$page_restrictor = './restrictor/page.restrictor.php'; //Pfad zum page_restrictor-Script

##########Funktionen##########
function platform($user_agent){
if(eregi("NT 5.1", $user_agent) || eregi("Windows XP", $user_agent)){ return 'Windows XP'; }
else if(eregi("Windows 2000", $user_agent) || eregi("Win2000", $user_agent) || eregi("NT 5.0", $user_agent)){ return 'Windows 2000'; }
else if(eregi("Win 9x 4.90", $user_agent) || eregi("WinME", $user_agent) || eregi("Windows ME", $user_agent)){ return 'Windows ME'; }
else if(eregi("NT", $user_agent)){ return 'Windows NT'; }
else if(eregi("Win98", $user_agent) || eregi("Windows 98", $user_agent)){ return 'Windows 98'; }
else if(eregi("Win95", $user_agent) || eregi("Windows 95", $user_agent)){ return 'Windows 95'; }
else if(eregi("Windows CE", $user_agent)){ return 'Windows CE (Pocket PC)'; }
else if(eregi("Win", $user_agent)){ return 'Windows (andere)'; }
else if(eregi("Mac", $user_agent)){ return 'Macintosh'; }
else if(eregi("Unix", $user_agent) || eregi("hp-ux", $user_agent)){ return 'Unix'; }
else if(eregi("X11", $user_agent) || eregi("Linux", $user_agent) || eregi("Konqueror", $user_agent)){ return 'Linux'; }
else if(eregi("OS/2", $user_agent)){ return 'OS/2"'; }
else if(eregi("SunOS", $user_agent)){ return 'SunOS'; }
else if(eregi("BeOS", $user_agent)){ return 'BeOS'; }
else if(eregi("FreeBSD", $user_agent)){ return 'FreeBSD'; }
else if(eregi("OpenBSD", $user_agent)){ return 'OpenBSD'; }
else if(eregi("Irix", $user_agent)){ return 'Irix'; }
else if(eregi("Plan9", $user_agent)){ return 'Plan9'; }
else if(eregi("OSF", $user_agent)){ return 'OSF'; }
else{ return $user_agent; }
}

function browser($user_agent){
if(eregi("Opera[ |/]{0,1}([1-9])", $user_agent, $regs)){ return 'Opera '.$regs[1]; }
else if(eregi("Konqueror/([1-9])", $user_agent, $regs)){ return 'Konqueror '.$regs[1]; }
else if(eregi("Netscape[ |/]{0,1}([1-9])", $user_agent, $regs)){ return 'Netscape '.$regs[1]; }
else if(eregi("MSIE ([1-9])", $user_agent, $regs)){ return 'MS Internet Explorer '.$regs[1]; }
else if(eregi("Chimera[ |/]{0,1}([0-9].[1-9])", $user_agent, $regs)){ return 'Chimera '.$regs[1]; }
else if(eregi("Dillo", $user_agent, $regs)){ return 'Dillo'; }
else if(eregi("DocZilla/([1-9])", $user_agent, $regs)){ return 'DocZilla '.$regs[1]; }
else if(eregi("Galeon[ |/]{0,1}([0-9].[1-9])", $user_agent, $regs)){ return 'Galeon '.$regs[1]; }
else if(eregi("iCab[ |/]{0,1}([1-9])", $user_agent, $regs)){ return 'iCab '.$regs[1]; }
else if(eregi("ICE Browser[ |/]{0,1}([1-9])", $user_agent, $regs)){ return 'ICE Browser '.$regs[1]; }
else if(eregi("K-Meleon[ |/]{0,1}([0-9].[1-9])", $user_agent, $regs)){ return 'K-Meleon '.$regs[1]; }
else if(eregi("Oregano", $user_agent, $regs)){ return 'Oregano'; }
else if(eregi("Phoenix[ |/]{0,1}([0-9].[1-9])", $user_agent, $regs)){ return 'Phoenix '.$regs[1]; }
else if(eregi("amaya/([1-9])", $user_agent, $regs)){ return 'Amaya '.$regs[1]; }
else if(eregi("Safari", $user_agent)){ return 'Safari'; }
else if(eregi("Mozilla", $user_agent) && eregi("Gecko", $user_agent)){ return 'Mozilla'; }
else if(eregi("Mozilla/([1-9])", $user_agent, $regs)){ return 'Netscape '.$regs[1]; }
else{ return $user_agent; }
}

function cmp($a, $b) {
if($_GET['sort'] == ''){ $sort = 0; }
else{ $sort = $_GET['sort']; }
   return strcmp($a[$sort], $b[$sort]);
}

function mcmp($a, $b) {
if($_GET['sort'] == ''){ $sort = 0; }
else{ $sort = $_GET['sort']; }
   return -strcmp($a[$sort], $b[$sort]);
}
##########Ende##########
// EINFUEGEN, wenn eigenes Style nicht 'passt'.
/*
echo '<style>
.boxcontent,
.boxcontent a:visited,
.boxcontent a:active,
.boxcontent a:link {
	color: #002063;
	font: 10px Verdana, Geneva, Arial, Helvetica, sans-serif;
	text-decoration: none;
	background: transparent;
}

.boxcontent a:hover {
	color: #399EF7;
	font: 10px Verdana, Geneva, Arial, Helvetica, sans-serif;
	text-decoration: underline;
	background: transparent;
}
</style>';
*/
include('header.php');
Opentable();
echo "<hr /><center><h3><b>PageRestrictor Log-File vom ".date("d.m.Y")."</b></h3></center><br>";
echo '<a href="./admin.php">Admin Menue</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&page=&logfile='.$_GET['logfile'].'">Logfile</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&page=stats&logfile='.$_GET['logfile'].'">Statistik</a>&nbsp;|
<a href="/index.php?pres=check" target="_self">PageRestrictor-Check</a>&nbsp;|
<a href="/index.php?pres=update" target="_self">PageRestrictor-Update</a>&nbsp;|
<a href="http://www.bot-trap.de">Home Bot-Trap</a><br>';

// Falls ein neues PageRestrictor-File erforderlich, nchste Zeile einblenden. Fuer XXXXXXX, setzte bitte Deinen Code ein. 
//echo '<a href="http://www.bot-trap.de/download.php?do=get&id=1&code=XXXXXX" >PageRestrictor-Download</a>';

if($_GET['page'] == ''){
if($_GET['order'] == 'ASC'){ $nextorder = 'DESC'; }
elseif($_GET['order'] == 'DESC'){ $nextorder = 'ASC'; }
else{ $nextorder = 'DESC'; }
echo '<br><br>';
$checklog = strlen($logfile)-1;
$checklog = substr($logfile, $checklog );
if($checklog == "/"){
echo '<form action="" method="GET"><select name="logfile">';
if($dir = opendir($logfile)){
while($file=readdir($dir)){
$checkfile = substr($file, -4);
if (!is_dir($file) && $file != "." && $file != ".." && $checkfile == '.log'){
echo '<option value="'.$logfile.$file.'"'; if($_GET['logfile'] == $file){ echo 'selected'; } echo '>'.$file.'</option>';
}
}
closedir($dir);
}
echo '</select><input type="submit" name="submit" value="auswaehlen"></form>';
}
if($_GET['submit'] == 'auswaehlen' || $_GET['logfile'] != ''){
$logfile = $_GET['logfile'];
}
echo '<b>Sortieren nach:</b><br />
[&nbsp;<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=0&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Datum/Uhrzeit</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=1&order='.$nextorder.'&logfile='.$_GET['logfile'].'">IP/Host</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=2&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Browser/Betriebssystem</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=3&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Referer</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=4&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Request</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=5&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Grund</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&sort=6&order='.$nextorder.'&logfile='.$_GET['logfile'].'">Grund-Details</a>&nbsp;]
<br /><br />
<b>Grund-Filter:</b><br />
[&nbsp;<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&logfile='.$_GET['logfile'].'&filter=ip">IP</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&logfile='.$_GET['logfile'].'&filter=iprange">IP-Range</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&logfile='.$_GET['logfile'].'&filter=ua">UserAgent</a>&nbsp;|
<a href="'.$_SERVER['PHP_SELF'].'?name='.$module_name.'&op=RESTRICTORAdmin&logfile='.$_GET['logfile'].'&filter=ref">RefSpam</a>&nbsp;]
<br /><br /><br />';
// Today-file vorhanden ?//
if (@is_file($logfile)){
// Today-file vorhanden, JA//
if(substr($logfile, $logfile-4) == '.log'){
echo '<table class="boxcontent" width="100%" style="border:3px solid '.$bgcolor0.';" cellspacing="0" cellpadding="2">';
$lines = file($logfile);
$x = 0;
foreach ($lines as $line_num => $line){
$teile = explode(" - ", $line);
if(count($teile) == 7){
$datum = explode (".",$teile[0]);
$zeit = explode (":",$teile[0]);
$stunde = explode (" ",$zeit[0]);
$datumzeit = mktime($stunde[1],$zeit[1],$zeit[2],$datum[1],$datum[0],$datum[2]);
$array[$x] = array($datumzeit, $teile[1], $teile[2], $teile[3], $teile[4], $teile[5], $teile[6]);
$x++;
}
}
$anzahl_eintraege = count($array);

if($_GET['order'] != 'DESC'){ @usort($array, "cmp"); }
if($_GET['order'] == 'DESC'){ @usort($array, "mcmp"); }
while (list ($key, $value) = @each($array)) {
$browser = browser($array[$key][2]);
$platform = platform($array[$key][2]);
$date = date('d.m.Y H:i:s', $array[$key][0]);
$iphost = explode (" ",$array[$key][1]);

if($_GET['filter'] == '' || $array[$key][5] == $_GET['filter']){
echo '<tr style="background-color:'.$bgcolor2.';"><th style="border-right:1px solid '.$bgcolor0.';">Datum/Uhrzeit:</th><td width="100%">'.$date.'</td></tr>
<tr style="background-color:'.$bgcolor3.';"><th style="border-right:1px solid '.$bgcolor0.';"><a href="http://de.wikipedia.org/wiki/IP-Adresse" target="_blank">IP</a>/<a href="http://de.wikipedia.org/wiki/Hostname" target="_blank">Host</a>:</th><td width="100%"><a href="http://www.dnsstuff.com/tools/whois.ch?ip='.$iphost[0].'" target="_blank">'.$iphost[0].'</a> '.$iphost[1].'</td></tr>
<tr style="background-color:'.$bgcolor2.';"><th style="border-right:1px solid '.$bgcolor0.';"><a href="http://de.wikipedia.org/wiki/Browser" target="_blank">Browser</a>/<a href="http://de.wikipedia.org/wiki/Betriebssystem" target="_blank">Betriebssystem</a>:</th><td width="100%" title="'.$array[$key][2].'">'.$browser.' / '.$platform.'</td></tr>
<tr style="background-color:'.$bgcolor3.';"><th style="border-right:1px solid '.$bgcolor0.';"><a href="http://de.wikipedia.org/wiki/Referer" target="_blank">Referer</a>:</th><td width="100%">'.$array[$key][3].'</td></tr>
<tr style="background-color:'.$bgcolor2.';"><th style="border-right:1px solid '.$bgcolor0.';" title="zeigt an, auf welche URL zugegriffen wurde">Request:</th><td width="100%">'.$array[$key][4].'</td></tr>
<tr style="background-color:'.$bgcolor3.';"><th style="border-right:1px solid '.$bgcolor0.';">Grund:</th><td width="100%">'.$array[$key][5].'</td></tr>
<tr style="background-color:'.$bgcolor2.';"><th style="border-right:1px solid '.$bgcolor0.';">Grund-Details:</th><td width="100%">'.$array[$key][6].'</td></tr>';
echo '</table><br><table class="boxcontent" width="100%" style="border:3px solid '.$bgcolor0.';" cellspacing="0" cellpadding="2">';
}
}
echo '</table>';
}
// Today-file vorhanden, NEIN//
}else{ echo '<div align="center"><font color="red">No BadSpider visited, therefore no file <b>'.$logfile_name.'</b> exists.</font></div>'; }
}

if($_GET['page'] == 'stats'){
if($_GET['logfile'] != '') $logfile = $_GET['logfile'];
$lines = file($logfile);
$ip = 0;
$iprange = 0;
$ua = 0;
$ref = 0;
foreach ($lines as $line_num => $line){
$teile = explode(" - ", $line);
if(count($teile) == 7){
if($teile[5] == 'ip'){ $ip++; }
if($teile[5] == 'iprange'){ $iprange++; }
if($teile[5] == 'ua'){ $ua++; }
if($teile[5] == 'ref'){ $ref++; }
}
}
echo '<center><br /><br /><table class="boxcontent" style="border:3px solid '.$bgcolor0.';" cellspacing="0" cellpadding="2">
<tr><td colspan="2" align="center"><h3>Sperr-Gr&uuml;nde:</h3></td></tr>
<tr><th style="border-right:1px solid '.$bgcolor0.';border-top:1px solid '.$bgcolor0.';">Grund</td><th style="border-top:1px solid '.$bgcolor0.';">Anzahl</td></tr>
<tr align="center"><td style="border-right:1px solid '.$bgcolor0.';border-top:1px solid '.$bgcolor0.';">IP</td><td style="border-top:1px solid '.$bgcolor0.';">'.$ip.'</td></tr>
<tr align="center"><td style="border-right:1px solid '.$bgcolor0.';border-top:1px solid '.$bgcolor0.';">IP-Range</td><td style="border-top:1px solid '.$bgcolor0.';">'.$iprange.'</td></tr>
<tr align="center"><td style="border-right:1px solid '.$bgcolor0.';border-top:1px solid '.$bgcolor0.';">UserAgent</td><td style="border-top:1px solid '.$bgcolor0.';">'.$ua.'</td></tr>
<tr align="center"><td style="border-right:1px solid '.$bgcolor0.';border-top:1px solid '.$bgcolor0.';">RefSpam</td><td style="border-top:1px solid '.$bgcolor0.';">'.$ref.'</td></tr>
</table><br /><br /></center>';
}
CloseTable();
include('footer.php');
?>